%define 	pname mysql
%define 	pversion 5.0.27
%define 	bversion 100
%define 	rpmrelease iworx
%define		localstatedir /var/lib/mysql
%define 	mysqld_user mysql
%define		mysqld_port 3306
%define		socketdir /var/lib/mysql
%define		piddir /var/run/mysqld
%define 	server_suffix -standard
%define		mydotcnf my-large.cnf

%define 	debug_package %{nil}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#


%define 	build_rht_90   0
%define		build_cos_3x   0
%define		build_fdr_10   0
%define		build_fdr_20   0
%define		build_fdr_30   0
%define		build_fdr_40   0
%define		build_whb_3x   0
%define		build_rhe_2x   0
%define		build_rhe_3x   0
%define		build_rhe_4x   0

%define		build_unk      1

# Command Line Overrides
%{?_with_rht90:   	%{expand: %%define build_rht_90   1}}
%{?_with_cos3x: 	%{expand: %%define build_cos_3x   1}}
%{?_with_fdr10: 	%{expand: %%define build_fdr_10   1}}
%{?_with_fdr20: 	%{expand: %%define build_fdr_20   1}}
%{?_with_fdr30: 	%{expand: %%define build_fdr_30   1}}
%{?_with_fdr40: 	%{expand: %%define build_fdr_40   1}}
%{?_with_whb3x: 	%{expand: %%define build_whb_3x   1}}
%{?_with_rhe2x: 	%{expand: %%define build_rhe_2x   1}}
%{?_with_rhe3x: 	%{expand: %%define build_rhe_3x   1}}
%{?_with_rhe4x: 	%{expand: %%define build_rhe_4x   1}}

%{?_with_unk: 		%{expand: %%define build_unk      1}}

# Distro Statements

%if %{build_rht_90}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype RedHat 9
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_cos_3x}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype CentOS 3.x
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_10}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Fedora Core 1
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_20}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Fedora Core 2
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_30}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Fedora Core 3
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_40}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Fedora Core 4
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_whb_3x}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype White Box 3.x
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_2x}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype RedHat Enterprise 2.x
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_3x}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype RedHat Enterprise 3.x
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_4x}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype RedHat Enterprise 4.x / CentOS 4.x
BuildRequires:	ncurses-devel
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Unknown Distribution
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary:	MySQL: a very fast and reliable SQL database server
Name: 		%{pname}
Version: 	%{pversion}
Release: 	%{release}
License:	GPL

Group:		Applications/Databases
Source0:	%{name}-%{version}.tar.gz
URL:		http://www.mysql.com/

Distribution:	InterWorx-HAL
Vendor:         NEXCESS.NET L.L.C
Packager:	Chris Wells <clwells@nexcess.net>

Requires: 	fileutils sh-utils

BuildRoot:	%{_tmppath}/%{name}-%{version}-root

Source1:	mysqld.init
Source2:	mysql-my.cnf

%description
The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
and robust SQL (Structured Query Language) database server. MySQL Server
is intended for mission-critical, heavy-load production systems as well
as for embedding into mass-deployed software. MySQL is a trademark of
MySQL AB.

The MySQL software has Dual Licensing, which means you can use the MySQL
software free of charge under the GNU General Public License
(http://www.gnu.org/licenses/). You can also purchase commercial MySQL
licenses from MySQL AB if you do not wish to be bound by the terms of
the GPL. See the chapter "Licensing and Support" in the manual for
further info.

The MySQL web site (http://www.mysql.com/) provides the latest
news and information about the MySQL software. Also please see the
documentation and the manual for more information.

%package server
Release: %{release}
Summary:	MySQL: a very fast and reliable SQL database server
Group:		Applications/Databases
Requires: 	fileutils 
Requires:	sh-utils
Requires:	perl
Requires:	perl-DBI 
Provides:	msqlormysql mysql-server mysql MySQL
Obsoletes:	MySQL mysql mysql-server

%description server
The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
and robust SQL (Structured Query Language) database server. MySQL Server
is intended for mission-critical, heavy-load production systems as well
as for embedding into mass-deployed software. MySQL is a trademark of
MySQL AB.

The MySQL software has Dual Licensing, which means you can use the MySQL
software free of charge under the GNU General Public License
(http://www.gnu.org/licenses/). You can also purchase commercial MySQL
licenses from MySQL AB if you do not wish to be bound by the terms of
the GPL. See the chapter "Licensing and Support" in the manual for
further info.

The MySQL web site (http://www.mysql.com/) provides the latest
news and information about the MySQL software. Also please see the
documentation and the manual for more information.

This package includes the MySQL server binary (statically linked,
compiled with InnoDB support) as well as related utilities to run
and administrate a MySQL server.

If you want to access and work with the database, you have to install
package "MySQL-client" as well!

%package client
Summary:	MySQL - Client
Release: 	%{release}
Group: 		Applications/Databases
Requires:	perl-DBI 
Obsoletes:	mysql-client
Provides: 	mysql-client

%description client
This package contains the standard MySQL clients and administration tools. 

%{see_base}

%package bench
Summary: 	MySQL - Benchmarks and test system
Group: 		Applications/Databases
Release: 	%{release}
Requires: 	%{name}-client 
Requires:	perl-DBI 
Requires:	perl
Provides: 	mysql-bench
Obsoletes: 	mysql-bench

%description bench
This package contains MySQL benchmark scripts and data.

%{see_base}

%package devel
Summary: 	MySQL - Development header files and libraries
Release: 	%{release}
Group: 		Applications/Databases
Provides: 	mysql-devel
Obsoletes: 	mysql-devel

%description devel
This package contains the development header files and libraries
necessary to develop MySQL client applications.

%{see_base}

%package shared
Summary: 	MySQL - Shared libraries
Release: 	%{release}
Group: 		Applications/Databases

%description shared
This package contains the shared libraries (*.so*) which certain
languages and applications need to dynamically load and use MySQL.

%package max
Summary: 	MySQL - server with Berkeley BD, RAID and UDF support
Release: 	%{release}
Group: 		Applications/Databases
Provides: 	mysql-max
Obsoletes: 	mysql-max
Requires: 	mysql >= 4.0

%description max 
Optional MySQL server binary that supports additional features like
Berkeley DB, RAID and User Defined Functions (UDFs).
To activate this binary, just install this package in addition to
the standard MySQL package.

Please note that this is a dynamically linked binary!

%prep
%setup -q 

# Try detecting newest gcc (some distributions have got more then one compiler)
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{name}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{name}-%{pversion}-gcc
fi

# Display compilation flags and OS with nice colors
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags

%build

BuildMySQL() {
# The --enable-assembler simply does nothing on systems that does not
# support assembler speedups.
sh -c  "PATH=\"${MYSQL_BUILD_PATH:-$PATH}\" \
	CC=\"${CC:-$MYSQL_BUILD_CC}\" \
	CXX=\"${CXX:-$MYSQL_BUILD_CXX}\" \
	CFLAGS=\"${MYSQL_BUILD_CFLAGS:-$RPM_OPT_FLAGS}\" \
	CXXFLAGS=\"${MYSQL_BUILD_CXXFLAGS:-$RPM_OPT_FLAGS \
	          -felide-constructors -fno-exceptions -fno-rtti \
		  }\" \
	./configure \
 	    $* \
	    --enable-assembler \
	    --enable-local-infile \
            --with-mysqld-user=%{mysqld_user} \
            --with-unix-socket-path=%{socketdir}/mysql.sock \
            --prefix=%{_prefix} \
	    --with-extra-charsets=complex \
            --exec-prefix=%{_exec_prefix} \
            --libexecdir=%{_sbindir} \
            --libdir=%{_libdir} \
            --sysconfdir=%{_sysconfdir} \
            --datadir=%{_datadir} \
            --localstatedir=%{localstatedir} \
            --infodir=%{_infodir} \
            --includedir=%{_includedir} \
            --mandir=%{_mandir} \
            --without-debug \
            --without-ndb-debug \
	    --enable-thread-safe-client \
	    --with-readline \
	    --with-comment=\"InterWorx (TM) RPM\";
	    "

 # benchdir does not fit in above model. Maybe a separate bench distribution
 %{__make} %{?_smp_mflags} benchdir_root=%{buildroot}/usr/share/
}

# Use our own copy of glibc
OTHER_LIBC_DIR=/usr/local/mysql-glibc
USE_OTHER_LIBC_DIR=""
if test -d "$OTHER_LIBC_DIR"
then
  USE_OTHER_LIBC_DIR="--with-other-libc=$OTHER_LIBC_DIR"
fi

# Clean up the BuildRoot first
[ "%{buildroot}" != "/" ] && [ -d %{buildroot} ] && rm -rf %{buildroot};
mkdir -p %{buildroot}%{_libdir}/mysql

#
# Use MYSQL_BUILD_PATH so that we can use a dedicated version of gcc
#
PATH=${MYSQL_BUILD_PATH:-/bin:/usr/bin}
export PATH

# Use gcc for C and C++ code (to avoid a dependency on libstdc++ and
# including exceptions into the code
if [ -z "$CXX" -a -z "$CC" ]
then
	export CC="gcc"
	export CXX="gcc"
fi

# Build the 4.0 Max binary (includes BDB and UDFs and therefore
# cannot be linked statically against the patched glibc)

# Use gcc for C and C++ code (to avoid a dependency on libstdc++ and
# including exceptions into the code
if [ -z "$CXX" -a -z "$CC" ]
then
	export CC="gcc"
	export CXX="gcc"
fi

BuildMySQL "--enable-shared \
		--without-openssl \
		--with-berkeley-db \
		--with-innodb \
		--with-raid \
		--with-archive \
		--with-csv-storage-engine \
		--with-example-storage-engine \
		--with-embedded-server \
		--with-server-suffix='-max'"

# Save mysqld-max
mv sql/mysqld sql/mysqld-max
#nm --numeric-sort sql/mysqld-max > sql/mysqld-max.sym

# Install embedded server library in the build root
install -m 644 libmysqld/libmysqld.a $RBR%{_libdir}/mysql/

# Include libgcc.a in the devel subpackage (BUG 4921)
if [ "$CC" = gcc ]
then
  libgcc=`$CC --print-libgcc-file`
  if [ -f $libgcc ]
  then
    %define have_libgcc 1
    install -m 644 $libgcc $RBR%{_libdir}/mysql/libmygcc.a
  fi
fi

# Save libraries
(cd libmysql/.libs; tar cf %{buildroot}/shared-libs.tar *.so*)
(cd libmysql_r/.libs; tar rf %{buildroot}/shared-libs.tar *.so*)

# Save manual to avoid rebuilding
mv Docs/manual.ps Docs/manual.ps.save || :
make clean
mv Docs/manual.ps.save Docs/manual.ps || :

# RPM:s destroys Makefile.in files, so we generate them here
# aclocal; autoheader; aclocal; automake; autoconf
# (cd innobase && aclocal && autoheader && aclocal && automake && autoconf)

# Now build the statically linked 4.0 binary (which includes InnoDB)
BuildMySQL "--disable-shared \
		--with-mysqld-ldflags='-all-static' \
		--with-client-ldflags='-all-static' \
		$USE_OTHER_LIBC_DIR \
		--with-server-suffix='%{server_suffix}' \
		--without-embedded-server \
		--without-berkeley-db \
		--with-innodb \
		--without-vio \
		--without-openssl"
#nm --numeric-sort sql/mysqld > sql/mysqld.sym

%install
MYSQL_BUILD_PATH=$RPM_BUILD_DIR/%{name}-%{version}

# Ensure that needed directories exists
install -d %{buildroot}%{_sysconfdir}/{logrotate.d,init.d}
install -d %{buildroot}%{_datadir}/{sql-bench,mysql-test}
install -d %{buildroot}%{_includedir}
install -d %{buildroot}%{_libdir}
install -d %{buildroot}%{_mandir}
install -d %{buildroot}%{_sbindir}
install -d -m0711 %{buildroot}%{socketdir}
install -d -m0711 %{buildroot}%{piddir}

# Install all binaries stripped 
%{__make} %{?_smp_flags} \
	install-strip DESTDIR=%{buildroot} benchdir_root=%{_datadir}

# Install shared libraries (Disable for architectures that don't support it)
(cd %{buildroot}%{_libdir}; tar xf %{buildroot}/shared-libs.tar; rm -f %{buildroot}/shared-libs.tar)

# install saved mysqld-max
install -s -m755 $MYSQL_BUILD_PATH/sql/mysqld-max \
	%{buildroot}%{_sbindir}/mysqld-max

# install symbol files ( for stack trace resolution)
#install -m644 $MYSQL_BUILD_PATH/sql/mysqld-max.sym \
#	%{buildroot}%{_libdir}/mysql/mysqld-max.sym
#install -m644 $MYSQL_BUILD_PATH/sql/mysqld.sym \
#	%{buildroot}%{_libdir}/mysql/mysqld.sym

# Install logrotate and autostart
install -m644 $MYSQL_BUILD_PATH/support-files/mysql-log-rotate \
	%{buildroot}%{_sysconfdir}/logrotate.d/mysql

# install the init.d script
piddir=%{piddir}
socketdir=%{socketdir}
localstatedir=%{localstatedir}

esc_piddir=${piddir//\//\\/}
esc_socketdir=${socketdir//\//\\/}
esc_localstatedir=${localstatedir//\//\\/}

sed "s/@DATADIR@/$esc_localstatedir/" %{SOURCE1} | \
	sed "s/@PIDDIR@/$esc_piddir/" | \
	sed "s/@USER@/%{mysqld_user}/" \
	> %{buildroot}%{_sysconfdir}/init.d/mysqld

# install the my.cnf
sed "s/@localstatedir@/$esc_localstatedir/" %{SOURCE2} | \
	sed "s/@MYSQL_TCP_PORT@/%{mysqld_port}/" | \
	sed "s/@MYSQL_UNIX_ADDR@/$esc_socketdir\/mysql.sock/" | \
	sed "s/@PIDDIR@/$esc_piddir/" \
	> %{buildroot}%{_sysconfdir}/my.cnf
chmod 640 %{buildroot}%{_sysconfdir}/my.cnf


# Create a symlink "rcmysql", pointing to the init.script. SuSE users
# will appreciate that, as all services usually offer this.
#ln -s %{buildroot}%{_sysconfdir}/init.d/mysqld %{buildroot}%{_sbindir}/rcmysql

# Touch the place where the my.cnf config file might be located
# Just to make sure it's in the file list and marked as a config file
touch %{buildroot}%{_sysconfdir}/my.cnf

# kill unneeded files
rm -f %{buildroot}%{_bindir}/make_win_binary_distribution
rm -f %{buildroot}%{_bindir}/make_win_src_distribution
rm -f %{buildroot}%{_infodir}/dir

%pre server

# Create data directory if needed
if test ! -d %{localstatedir}; then mkdir -m755 %{localstatedir}; fi

# Create a MySQL user. Do not report any problems if it already
# exists. This is redhat specific and should be handled more portable
useradd -c "MySQL server" -M -r -d %{localstatedir} \
	-s /bin/bash %{mysqld_user} 2> /dev/null || true 

# make sure mysql owns its homedir
chmod -R 711 %{localstatedir}
chown -R %{mysqld_user} %{localstatedir}

# Shut down a previously installed server first
if test -x %{_sysconfdir}/init.d/mysqld
then
  %{_sysconfdir}/init.d/mysqld stop > /dev/null 2>&1
  echo "Giving mysqld a couple of seconds to exit nicely"
  sleep 3
  killall mysqld || true
elif test -x %{_sysconfdir}/rc.d/init.d/mysqld
then
  %{_sysconfdir}/rc.d/init.d/mysqld stop > /dev/null 2>&1
  echo "Giving mysqld a couple of seconds to exit nicely"
  sleep 5
fi

%post server

# Make MySQL start/shutdown automatically when the machine does it.
# use insserv for older SuSE Linux versions
if test -x /sbin/insserv
then
	/sbin/insserv %{_sysconfdir}/init.d/mysqld
# use chkconfig on Red Hat and newer SuSE releases
elif test -x /sbin/chkconfig
then
	/sbin/chkconfig --add mysqld
	/sbin/chkconfig --level 345 mysqld on
fi

# Restart in the same way that mysqld will be started normally.
echo "Restarting mysqld."
%{_sysconfdir}/init.d/mysqld restart

# Allow safe_mysqld to start mysqld and print a message before we exit
sleep 2

%post max
# Restart mysqld, to use the new binary.
echo "Restarting mysqld."
%{_sysconfdir}/init.d/mysqld restart > /dev/null 2>&1

%preun server
if test $1 = 0
then
	# Stop MySQL before uninstalling it
  if test -x %{_sysconfdir}/init.d/mysqld
  then
    %{_sysconfdir}/init.d/mysqld stop > /dev/null
  fi

  # Remove autostart of mysql
	# for older SuSE Linux versions
	if test -x /sbin/insserv
	then
		/sbin/insserv -r %{_sysconfdir}/init.d/mysqld
	# use chkconfig on Red Hat and newer SuSE releases
	elif test -x /sbin/chkconfig
	then
		/sbin/chkconfig --del mysqld
	fi
fi

# We do not remove the mysql user since it may still own a lot of
# database files.

# Clean up the BuildRoot
%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%files server
%defattr(-,root,root,0755)

%doc COPYING README
#%doc Docs/manual.{html,ps,texi,txt}
#%doc Docs/manual_toc.html
%doc support-files/my-*.cnf

%doc %attr(644, root, root) %{_infodir}/mysql.info*

%doc %attr(644, root, man) %{_mandir}/man1/mysql_zap.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqld.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysql_fix_privilege_tables.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqld_multi.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqld_safe.1*
%doc %attr(644, root, man) %{_mandir}/man1/perror.1*
%doc %attr(644, root, man) %{_mandir}/man1/replace.1*
%doc %attr(644, root, man) %{_mandir}/man1/msql2mysql.1.gz
%doc %attr(644, root, man) %{_mandir}/man1/myisamchk.1.gz
%doc %attr(644, root, man) %{_mandir}/man1/myisamlog.1.gz
%doc %attr(644, root, man) %{_mandir}/man1/myisampack.1.gz
%doc %attr(644, root, man) %{_mandir}/man1/mysql.server.1.gz
%doc %attr(644, root, man) %{_mandir}/man1/mysql_config.1.gz
%doc %attr(644, root, man) %{_mandir}/man1/mysqlbinlog.1.gz
%doc %attr(644, root, man) %{_mandir}/man1/mysqlcheck.1.gz
%doc %attr(644, root, man) %{_mandir}/man1/mysqlhotcopy.1.gz
%doc %attr(644, root, man) %{_mandir}/man1/mysqlimport.1.gz
%doc %attr(644, root, man) %{_mandir}/man1/mysqlman.1.gz
%doc %attr(644, root, man) %{_mandir}/man1/mysqlmanager.1.gz
%doc %attr(644, root, man) %{_mandir}/man1/safe_mysqld.1.gz
%doc %attr(644, root, man) %{_mandir}/man1/mysql_upgrade.1.gz

%config(noreplace,missingok) %{_sysconfdir}/my.cnf

%attr(755, root, root) %{_bindir}/my_print_defaults
%attr(755, root, root) %{_bindir}/myisamchk
%attr(755, root, root) %{_bindir}/myisam_ftdump
%attr(755, root, root) %{_bindir}/myisamlog
%attr(755, root, root) %{_bindir}/myisampack
%attr(755, root, root) %{_bindir}/mysql_convert_table_format
%attr(755, root, root) %{_bindir}/mysql_explain_log
%attr(755, root, root) %{_bindir}/mysql_fix_extensions
%attr(755, root, root) %{_bindir}/mysql_fix_privilege_tables
%attr(755, root, root) %{_bindir}/mysql_install_db
%attr(755, root, root) %{_bindir}/mysqltestmanager
%attr(755, root, root) %{_bindir}/mysqltestmanager-pwgen
%attr(755, root, root) %{_bindir}/mysqltestmanagerc
#%attr(755, root, root) %{_bindir}/mysql_install
%attr(755, root, root) %{_bindir}/mysql_secure_installation
%attr(755, root, root) %{_bindir}/mysql_setpermission
%attr(755, root, root) %{_bindir}/mysql_zap
%attr(755, root, root) %{_bindir}/mysqlbug
%attr(755, root, root) %{_bindir}/mysqld_multi
%attr(755, root, root) %{_bindir}/mysqld_safe
%attr(755, root, root) %{_bindir}/mysqlhotcopy
%attr(755, root, root) %{_bindir}/mysqltest
%attr(755, root, root) %{_bindir}/perror
%attr(755, root, root) %{_bindir}/replace
%attr(755, root, root) %{_bindir}/resolve_stack_dump
%attr(755, root, root) %{_bindir}/resolveip
%attr(755, root, root) %{_bindir}/mysql_create_system_tables
%attr(755, root, root) %{_bindir}/mysql_tzinfo_to_sql
%attr(755, root, root) %{_bindir}/innochecksum
%attr(755, root, root) %{_bindir}/mysql_upgrade

%attr(755, root, root) %{_sbindir}/mysqld
%attr(755, root, root) %{_sbindir}/mysqlmanager
#%attr(755, root, root) %{_sbindir}/rcmysql
#%attr(644, root, root) %{_libdir}/mysql/mysqld.sym
#%attr(644, root, root) %{_libdir}/mysql/libz.a
#%attr(644, root, root) %{_libdir}/mysql/libz.la


%attr(644, root, root) %config(noreplace,missingok) %{_sysconfdir}/logrotate.d/mysql
%attr(700, root, root) %config(noreplace) %{_sysconfdir}/init.d/mysqld

%attr(711, %{mysqld_user}, %{mysqld_user}) %{_datadir}/mysql/
%attr(711, %{mysqld_user}, %{mysqld_user}) %{socketdir}
%attr(711, %{mysqld_user}, %{mysqld_user}) %{piddir}

%files client
%defattr(-, root, root, 0755)
%attr(755, root, root) %{_bindir}/msql2mysql
%attr(755, root, root) %{_bindir}/mysql
%attr(755, root, root) %{_bindir}/mysql_find_rows
%attr(755, root, root) %{_bindir}/mysql_tableinfo
%attr(755, root, root) %{_bindir}/mysql_waitpid
%attr(755, root, root) %{_bindir}/mysqlaccess
%attr(755, root, root) %{_bindir}/mysqladmin
%attr(755, root, root) %{_bindir}/mysqlbinlog
%attr(755, root, root) %{_bindir}/mysqlcheck
%attr(755, root, root) %{_bindir}/mysqldump
%attr(755, root, root) %{_bindir}/mysqldumpslow
%attr(755, root, root) %{_bindir}/mysqlimport
%attr(755, root, root) %{_bindir}/mysqlshow
%attr(755, root, root) %{_bindir}/mysql_client_test
%attr(755, root, root) %{_bindir}/mysql_upgrade_shell

%doc %attr(644, root, man) %{_mandir}/man1/mysql.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqlaccess.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqladmin.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqldump.1*
%doc %attr(644, root, man) %{_mandir}/man1/mysqlshow.1*
%doc %attr(644, root, man) %{_mandir}/man1/myisam_ftdump.1.gz
%doc %attr(644, root, man) %{_mandir}/man1/mysql_explain_log.1.gz
%doc %attr(644, root, man) %{_mandir}/man8/mysqld.8.gz
%doc %attr(644, root, man) %{_mandir}/man8/mysqlmanager.8.gz

%post shared
/sbin/ldconfig

%postun shared
/sbin/ldconfig

%files devel
%defattr(-, root, root, 0755)
%attr(755, root, root) %{_bindir}/comp_err
%attr(755, root, root) %{_bindir}/mysql_config
%dir %attr(755, root, root) %{_includedir}/mysql
%dir %attr(755, root, root) %{_libdir}/mysql
%{_includedir}/mysql/*
%{_libdir}/mysql/libdbug.a
%{_libdir}/mysql/libheap.a
%{_libdir}/mysql/libmyisam.a
%{_libdir}/mysql/libmyisammrg.a
%{_libdir}/mysql/libmysqlclient.a
%{_libdir}/mysql/libmysqlclient.la
%{_libdir}/mysql/libmysqlclient_r.a
%{_libdir}/mysql/libmysqlclient_r.la
%{_libdir}/mysql/libmystrings.a
%{_libdir}/mysql/libmysys.a
%{_libdir}/mysql/libvio.a

%files shared
%defattr(-, root, root, 0755)
# Shared libraries (omit for architectures that don't support them)
%{_libdir}/*.so*

%files bench
%defattr(-, root, root, 0755)
%attr(-, root, root) %{_datadir}/sql-bench
%attr(-, root, root) %{_datadir}/mysql-test

%files max
%defattr(-, root, root, 0755)
%attr(755, root, root) %{_sbindir}/mysqld-max
#%attr(644, root, root) %{_libdir}/mysql/mysqld-max.sym

%changelog 
* Wed Sep 15 2004 Chris Wells <clwells@nexcess.net>
- Trying to force mysqld to quit after the 'nice' stoppage
* Mon Sep 13 2004 Chris Wells <clwells@nexcess.net>
- Upgraded to 4.0.21 and fixed a mysqld.init bug where
  the pid file was being looked for in the wrong dir.
- Tweaking how mysql is started / stopped on update
* Tue Jun 28 2004 Chris Wells <clwells@nexcess.net>
- Initial packaging as part of InterWorx-HAL OS
